program nitrodir;

{$mode objfpc}

uses
  ctypes, nds9, filesystem;

procedure dirlist(path: pchar);
var
  MyDir: PDIR;
  dnbuf: pchar;
  pent: pdirent;  
  statbuf: PStat;        
begin
  GetMem(MyDir, sizeof(PDIR));
  GetMem(pent, sizeof(dirent));
  GetMem(statbuf, sizeof(PStat));
  MyDir := opendir(path);

  if (MyDir <> nil) then
  begin
    while true do
    begin
{
      pent := readdir(MyDir);
      if pent = nil then 
        exit;
  
      if (strcmp('.', pent^.d_name) <> 0) and (strcmp('..', pent^.d_name) <> 0) then
      begin
        dnbuf := malloc(strlen(pent^.d_name) + strlen(path) + 2);
        if (strcmp('/',path) = 0) then 
          sprintf(dnbuf, '%s/%s', '', pent^.d_name)
        else
          sprintf(dnbuf, '%s/%s', path, pent^.d_name);
        _stat(dnbuf, statbuf^);
      
        if (S_ISDIR(statbuf^.st_mode)) then
        begin
          printf('%s <DIR>'#10, dnbuf);
          dirlist(dnbuf);
        end else 
        begin
          printf('%s (%d)'#10, dnbuf, statbuf^.st_size);
        end;
        free(dnbuf);
        free(statbuf);
      end;
}
    end;

    closedir(MyDir);
  end else 
  begin
    printf('opendir() failure.'#10);
  end;

end;

function f2vt(value: single): integer;  
begin  
  result := integer(trunc( single(value) * single(65535))); 
end;  

var
  a: integer;

begin	
  // Initialise the console, required for printf
  consoleDemoInit();
  
    printf('%i'#10, sizeof(DIR_ITER));
    printf('%i'#10, sizeof(dirent));
    printf('%i'#10, sizeof(DIR));
  
  a:= f2vt(0.4);
  printf('%i'#10, a);
  
{  
  if (nitroFSInit()) then
    dirlist('/')
  else 
    iprintf('nitroFSInit failure: terminating'#10);
}

  while true do
    swiWaitForVBlank();
end.